package database.helpers;

/**
 * A DatabaseEvent. An instance of this class is sent to
 * observers of the database.
 * 
 * @author Carl
 *
 */
public class DatabaseEvent {

	/**
	 * Object related to the event.
	 */
	private Object object;
	
	/**
	 * The specific event.
	 */
	private DatabaseEventType event;
	
	/**
	 * Creates a new {@link DatabaseEvent}.
	 * 
	 * @param object
	 * @param event
	 */
	public DatabaseEvent(Object object, DatabaseEventType event) {
		this.object = object;
		this.event = event;
	}

	/**
	 * @return the current Object related to the event.
	 */
	public Object getObject() {
		return object;
	}

	/**
	 * @return the specific event.
	 */
	public DatabaseEventType getEvent() {
		return event;
	}
	
}
