package globals;


import java.util.Calendar;

import database.Database;

/**
 * Thread which checks when it is time to grant interest.
 * 
 * @author Carl
 *
 */
public class InterestThread extends Thread {

	public void run() {
		while (true) {

			Calendar nextUpdate = Calendar.getInstance();

			switch (BankSettings.getInterestRate()) {
			case YEARLY:
				nextUpdate.add(Calendar.YEAR, 1);
				nextUpdate.set(Calendar.MONTH, Calendar.JANUARY);
				nextUpdate.set(Calendar.DAY_OF_MONTH, 1);
				nextUpdate.set(Calendar.AM_PM, Calendar.AM);
				nextUpdate.set(Calendar.HOUR_OF_DAY, 0);
				nextUpdate.set(Calendar.MINUTE, 0);
				nextUpdate.set(Calendar.SECOND, 0);
				nextUpdate.set(Calendar.MILLISECOND, 0);
				break;
			case MONTHLY:
				nextUpdate.add(Calendar.MONTH, 1);
				nextUpdate.set(Calendar.DAY_OF_MONTH, 1);
				nextUpdate.set(Calendar.AM_PM, Calendar.AM);
				nextUpdate.set(Calendar.HOUR_OF_DAY, 0);
				nextUpdate.set(Calendar.MINUTE, 0);
				nextUpdate.set(Calendar.SECOND, 0);
				nextUpdate.set(Calendar.MILLISECOND, 0);
				break;
			case WEEKLY:
				nextUpdate.add(Calendar.WEEK_OF_YEAR, 1);
				nextUpdate.set(Calendar.DAY_OF_WEEK, Calendar.MONDAY);
				nextUpdate.set(Calendar.AM_PM, Calendar.AM);
				nextUpdate.set(Calendar.HOUR_OF_DAY, 0);
				nextUpdate.set(Calendar.MINUTE, 0);
				nextUpdate.set(Calendar.SECOND, 0);
				nextUpdate.set(Calendar.MILLISECOND, 0);
				break;
			case DAILY:
				nextUpdate.add(Calendar.DAY_OF_MONTH, 1);
				nextUpdate.set(Calendar.AM_PM, Calendar.AM);
				nextUpdate.set(Calendar.HOUR_OF_DAY, 0);
				nextUpdate.set(Calendar.MINUTE, 0);
				nextUpdate.set(Calendar.SECOND, 0);
				nextUpdate.set(Calendar.MILLISECOND, 0);
				break;
			case HOURLY:
				nextUpdate.add(Calendar.HOUR_OF_DAY, 1);
				nextUpdate.set(Calendar.MINUTE, 0);
				nextUpdate.set(Calendar.SECOND, 0);
				nextUpdate.set(Calendar.MILLISECOND, 0);
				break;
			default:
				break;
			}
			
			nextUpdate.getTimeInMillis();

			while (Calendar.getInstance().before(nextUpdate)) {
				try {
					sleep(1000); // 1 s
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
			
			try {
				Database.getInstance().updateInterest();
			} catch (Throwable e) {
				e.printStackTrace();
			}
			
		}

	}
}
